diff --git a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index bba31dcd5..e43f9ee96 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -2,6 +2,8 @@ package net.betterthanadventure.utils;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
@@ -15,19 +17,18 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveFormatBase;
-import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
-import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import javax.swing.*;
@@ -494,12 +495,12 @@ public class BiomeFinder implements MinecraftAccessor {
 		BiomeProvider biomeProvider;
 		World world;
 		if (worldFolder == null){
-			biomeProvider = worldType.createBiomeProvider(new World(new SavedDataStorage(new LevelStorageDummy()), "", seed, dimension, worldType));
+			biomeProvider = worldType.createBiomeProvider(WorldEmpty.INSTANCE);
 			world = null;
 		} else {
 			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
-			LevelStorage saveHandler = saveFormat.getLevelStorage(worldFolder.getName(), false);
-			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), Dimension.OVERWORLD, null);
+			LevelStorage levelStorage = saveFormat.getLevelStorage(worldFolder.getName(), false);
+			world = new World(levelStorage, levelStorage.getLevelData().getWorldName(), levelStorage.getLevelData().getRandomSeed(), Dimension.OVERWORLD);
 			biomeProvider = worldType.createBiomeProvider(world);
 		}
 		allBiomes.clear();
@@ -650,11 +651,6 @@ public class BiomeFinder implements MinecraftAccessor {
 		return null;
 	}
 
-	@Override
-	public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
-		return new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
-	}
-
 	@Override
 	public int getAutosaveTimer() {
 		return 0;
@@ -670,4 +666,19 @@ public class BiomeFinder implements MinecraftAccessor {
 		return null;
 	}
 
+	private static final class World extends net.minecraft.core.world.World {
+		public World(final @NotNull LevelStorage levelStorage, final @Nullable String name, final long seed, final @NotNull Dimension dimension) {
+			super(levelStorage, name, seed, dimension, null);
+		}
+
+		@Override
+		public void setLightningFlicker(final int flicker) {
+			// Do nothing
+		}
+
+		@Override
+		protected @NotNull ChunkProvider createChunkProvider(@NotNull final LevelStorage levelStorage) {
+			return new ChunkProviderDynamic(this, levelStorage.getChunkLoader(this.dimension), this.getWorldType().createChunkGenerator(this));
+		}
+	}
 }
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index a5002e1af..da9d8804a 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -21,8 +21,8 @@ import net.minecraft.core.item.tool.ItemToolPickaxe;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.weather.Weather;
 import org.slf4j.Logger;
 
@@ -212,11 +212,6 @@ public class DataDumper implements MinecraftAccessor {
         return minecraftDir;
     }
 
-    @Override
-    public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
-        return null;
-    }
-
     @Override
     public int getAutosaveTimer() {
         return 0;
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 5be459f2d..0496247ab 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -176,8 +176,8 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveConverter;
@@ -773,19 +773,6 @@ public class Minecraft
         return VERSION;
     }
 
-    @Override
-    public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
-        return switch (GameSettings.CHUNK_PROVIDER.value) {
-            case DYNAMIC ->
-                new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
-
-            case THREADED ->
-                new ChunkProviderThreadedClient(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
-
-            default -> new ChunkProviderStatic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
-        };
-    }
-
     public static File getAppDir(String s) {
         String homeDirPath = System.getProperty("user.home", ".");
         File appDir;
@@ -1398,7 +1385,7 @@ public class Minecraft
         Debug.change("misc");
         this.worldRenderer.getMouseOver(1.0F);
         if (this.thePlayer != null) {
-            IChunkProvider chunkProvider = this.currentWorld.getChunkProvider();
+            ChunkProvider chunkProvider = this.currentWorld.getChunkProvider();
             int playerChunkX = MathHelper.floor_float((int) this.thePlayer.x) >> 4;
             int playerChunkZ = MathHelper.floor_float((int) this.thePlayer.z) >> 4;
             chunkProvider.setCurrentChunkOver(playerChunkX, playerChunkZ);
@@ -1634,8 +1621,8 @@ public class Minecraft
                 TileEntityRenderDispatcher.instance.tick();
 
                 Debug.change("entity");
-                if (this.currentWorld.lightningFlicker > 0) {
-                    this.currentWorld.lightningFlicker--;
+                if (this.currentWorld.getLightningFlicker() > 0) {
+                    this.currentWorld.setLightningFlicker(this.currentWorld.getLightningFlicker() - 1);
                 }
                 try {
                     this.currentWorld.updateEntities();
@@ -2053,6 +2040,7 @@ public class Minecraft
         }
 
         final @NotNull WorldClient world = new WorldClient(
+            this,
             levelStorage,
             worldConfiguration.getFinalWorldName(),
             worldConfiguration.getFinalNumericSeed(),
@@ -2083,7 +2071,7 @@ public class Minecraft
         int worldSaveVersion = 0;
 
         try {
-            LevelData info = new LevelData(new File(this.mcDataDir, "saves/" + worldDirName));
+            LevelData info = LevelData.fromWorldDir(new File(this.mcDataDir, "saves/" + worldDirName));
             worldSaveVersion = info.getSaveVersion();
         } catch (IOException e) {
             worldSaveVersion = this.saveFormat.getSaveVersion();
@@ -2102,7 +2090,7 @@ public class Minecraft
                 dimension = Dimension.OVERWORLD;
             }
 
-            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null);
+            WorldClient world = new WorldClient(this, saveHandler, null, 0L, dimension, null);
             this.statsCounter.add(StatList.loadWorldStat, 1);
             this.statsCounter.add(StatList.startGameStat, 1);
             changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
@@ -2179,7 +2167,7 @@ public class Minecraft
         this.sndManager.stopMusic();
         if (this.currentWorld != null) {
             this.currentWorld.saveWorldIndirectly(this.loadingScreen);
-            IChunkLoader loader = this.currentWorld.getLevelStorage().getChunkLoader(this.currentWorld.dimension);
+            ChunkLoader loader = this.currentWorld.getLevelStorage().getChunkLoader(this.currentWorld.dimension);
             if (loader != null) {
                 while (loader.isSaving()) {
                     try {
@@ -2220,7 +2208,7 @@ public class Minecraft
             if (this.particleEngine != null) {
                 this.particleEngine.setWorld(world);
             }
-            IChunkProvider ichunkprovider = world.getChunkProvider();
+            ChunkProvider ichunkprovider = world.getChunkProvider();
             int i = MathHelper.floor_float((int) this.thePlayer.x) >> 4;
             int j = MathHelper.floor_float((int) this.thePlayer.z) >> 4;
             ichunkprovider.setCurrentChunkOver(i, j);
@@ -2297,7 +2285,7 @@ public class Minecraft
         int i = 0;
         int j = (c * 2) / 16 + 1;
         j *= j;
-        IChunkProvider ichunkprovider = this.currentWorld.getChunkProvider();
+        ChunkProvider ichunkprovider = this.currentWorld.getChunkProvider();
         TilePos spawnPoint = this.currentWorld.getSpawnPoint();
         if (this.thePlayer != null) {
             spawnPoint.x = (int) this.thePlayer.x;
@@ -2370,7 +2358,7 @@ public class Minecraft
             bedSpawnCoordinates = this.currentWorld.getSpawnPoint();
             canRespawnAtBed = false;
         }
-        IChunkProvider ichunkprovider = this.currentWorld.getChunkProvider();
+        ChunkProvider ichunkprovider = this.currentWorld.getChunkProvider();
         ichunkprovider.setCurrentChunkOver(bedSpawnCoordinates.x >> 4, bedSpawnCoordinates.z >> 4);
         this.currentWorld.getRespawnLocation();
         this.currentWorld.updateEntityList();
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 9d7e0ed5e..9118aa0d5 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -209,7 +209,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
 	public void respawnPlayer()
     {
         sendInventoryChanged();
-        sendQueue.addToSendQueue(new PacketRespawn((byte)dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(world.worldType)));
+        sendQueue.addToSendQueue(new PacketRespawn((byte)dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(world.getWorldType())));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index 03c87103b..1a59d37df 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -15,6 +15,7 @@ import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.entity.Entity;
@@ -50,7 +51,7 @@ public class GuidebookPageMob
         this.mobInfo = mobInfo;
         Mob example = null;
         try {
-            example = EntityDispatcher.getInstance().createEntityInWorld(mobClass, WorldClient.EMPTY_WORLD);
+            example = EntityDispatcher.getInstance().createEntityInWorld(mobClass, WorldEmpty.INSTANCE);
         } catch (Exception e) {
             LOGGER.error("Failed to create example instance of mob '{}'!", mobClass.getSimpleName(), e);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index c887c7b46..dffb4cdec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -317,7 +317,7 @@ public class HudIngame extends Gui {
 
                     drawDebugScreenLine("Temperature: " + temperature + " Humidity: " + humidity);
 
-                    WindProvider windProvider = this.mc.currentWorld.worldType.getWindManager();
+                    WindProvider windProvider = this.mc.currentWorld.getWorldType().getWindManager();
                     if (windProvider != null) {
                         float direction = (float) floor100(windProvider.getWindDirection(this.mc.currentWorld, 0.0f, 500.0f, 0.0f));
                         float intensity = (float) floor100(windProvider.getWindIntensity(this.mc.currentWorld, 0.0f, 500.0f, 0.0f));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index 1ba7ed0f5..6732801a6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -141,7 +141,7 @@ public class HudComponentInfoOverlay
             }
             if (GameSettings.OVERLAY_SHOW_WEATHER.value) {
                 Weather weather = mc.currentWorld.getCurrentWeather();
-                if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather()) {
+                if (weather != null && weather != mc.currentWorld.getWorldType().getDefaultWeather()) {
                     drawString(I18n.getInstance().translateKey(weather.getNameLanguageKey()), x, y + tsp + lineHeight * line++, GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, rightAligned);
                 }
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 11b27bd85..21f188e8b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -32,6 +32,7 @@ import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.JavaProcess;
 import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
@@ -368,7 +369,7 @@ public abstract class OptionsPages {
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                                    mc.playerController = new PlayerControllerSP(mc);
-                                   mc.changeWorld(WorldClient.EMPTY_WORLD, "Loading Model Viewer");
+                                   mc.changeWorld(WorldEmpty.INSTANCE, "Loading Model Viewer");
                                    mc.displayScreen(new ScreenModelViewer());
                                }) {
                                    @Override
diff --git a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 2546a7b1b..2ed5d4e34 100644
--- a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -121,7 +121,7 @@ public class ClientCommandSource implements CommandSource {
 
     @Override
     public World getWorld(int dimension) {
-        return this.mc.currentWorld.dimension.id == dimension ? this.mc.currentWorld : new World(this.mc.currentWorld, Dimension.getDimensionList().get(dimension));
+        return this.mc.currentWorld.dimension.id == dimension ? this.mc.currentWorld : new WorldClient(this.mc.currentWorld, Dimension.getDimensionList().get(dimension));
     }
 
     public void movePlayerToDimension(Player player, int dimension) {
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index bc37df58f..8e708c319 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -69,8 +69,6 @@ import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.save.LevelStorageDummy;
-import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
@@ -93,7 +91,6 @@ public class PacketHandlerClient extends PacketHandler {
     private final Minecraft mc;
     private WorldClientMP worldClientMP;
     private boolean started; // Name from b1.2 leak
-    public SavedDataStorage savedDataStorage;
     public List<PlayerProfile> players;
     public HashMap<String, String> playerList = new HashMap<>();
     Random rand;
@@ -102,7 +99,6 @@ public class PacketHandlerClient extends PacketHandler {
         throws IOException {
         this.disconnected = false;
         this.started = false;
-        this.savedDataStorage = new SavedDataStorage(new LevelStorageDummy());
         this.rand = new Random();
         this.mc = minecraft;
         Socket socket = new Socket(InetAddress.getByName(host), port);
@@ -149,7 +145,7 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleLogin(@NotNull PacketLogin packetLogin) {
         this.mc.playerController = new PlayerControllerMP(this.mc, this);
         this.mc.statsCounter.add(StatList.joinMultiplayerStat, 1);
-        this.worldClientMP = new WorldClientMP(this, packetLogin.worldSeed, packetLogin.dimensionId, packetLogin.worldTypeId);
+        this.worldClientMP = new WorldClientMP(this, mc, packetLogin.worldSeed, packetLogin.dimensionId, packetLogin.worldTypeId);
         this.worldClientMP.isClientSide = true;
         this.mc.changeWorld(this.worldClientMP);
         this.mc.thePlayer.dimension = packetLogin.dimensionId;
@@ -686,7 +682,7 @@ public class PacketHandlerClient extends PacketHandler {
     @Override
     public void handleSetSpawnPosition(@NotNull PacketSetSpawnPosition packetSetSpawnPosition) {
         this.mc.thePlayer.setPlayerSpawnPoint(new TilePos(packetSetSpawnPosition.x, packetSetSpawnPosition.y, packetSetSpawnPosition.z));
-        this.mc.currentWorld.getLevelData().setSpawn(packetSetSpawnPosition.x, packetSetSpawnPosition.y, packetSetSpawnPosition.z);
+        this.mc.currentWorld.getLevelData().getSpawnPos().set(packetSetSpawnPosition.x, packetSetSpawnPosition.y, packetSetSpawnPosition.z);
     }
 
     @Override
@@ -749,7 +745,7 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleRespawn(@NotNull PacketRespawn packetRespawn) {
         if (packetRespawn.respawnDimensionId != this.mc.thePlayer.dimension) {
             this.started = false;
-            this.worldClientMP = new WorldClientMP(this, this.worldClientMP.getLevelData().getRandomSeed(), packetRespawn.respawnDimensionId, packetRespawn.respawnWorldTypeId);
+            this.worldClientMP = new WorldClientMP(this, mc, this.worldClientMP.getLevelData().getRandomSeed(), packetRespawn.respawnDimensionId, packetRespawn.respawnWorldTypeId);
             this.worldClientMP.isClientSide = true;
             this.mc.changeWorld(this.worldClientMP);
             this.mc.thePlayer.dimension = packetRespawn.respawnDimensionId;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index c1b375e69..ced5da4e6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -12,6 +12,7 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.client.util.helper.Buffer;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -43,7 +44,7 @@ public class LightmapHelper {
 	}
 	
 	public void setup() {
-		World world = this.mc.currentWorld;
+		WorldClient world = this.mc.currentWorld;
 		if(GameSettings.CUSTOM_LIGHTMAP.value && world != null) {
 			int dimension = world.dimension.id;
 			
@@ -67,7 +68,7 @@ public class LightmapHelper {
 	}
 
 	public void tick() {
-		World world = this.mc.currentWorld;
+		WorldClient world = this.mc.currentWorld;
 		if(world == null) {
 			return;
 		}
@@ -84,7 +85,7 @@ public class LightmapHelper {
 	}
 
 	public void update(float partialTicks) {
-		World world = this.mc.currentWorld;
+		WorldClient world = this.mc.currentWorld;
 
 		if(world == null) {
 			return;
@@ -143,11 +144,11 @@ public class LightmapHelper {
 				}
 				float modifiedSkylight = Math.max(0, skyLightLevel - skyDarken);
 				float light = Math.max(blockLightLevel, modifiedSkylight);
-				brightness = MathHelper.getInterpolate(world.worldType.getBrightnessRamp(), light);
+				brightness = MathHelper.getInterpolate(world.getWorldType().getBrightnessRamp(), light);
 			}else {
 				int modifiedSkylight = Math.max(0, skyLightLevel - world.skyDarken);
 				int light = Math.max(blockLightLevel, modifiedSkylight);
-				brightness = world.worldType.getBrightnessRamp()[light];
+				brightness = world.getWorldType().getBrightnessRamp()[light];
 			}
 			
 			brightness = applyGamma(brightness, GameSettings.BRIGHTNESS.value - 0.5f);
@@ -298,7 +299,7 @@ public class LightmapHelper {
 	}
 
 	public float getBrightnessRemoveMinLight(@NotNull World world, int i) {
-		float brightness = world.worldType.getBrightnessRamp()[i];
+		float brightness = world.getWorldType().getBrightnessRamp()[i];
 		float min = 0.05f;
 
 		return (brightness - min) / (1.0f - min);
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 07e442446..36e126c8b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -657,8 +657,8 @@ public class RenderGlobal
     }
 
     public void tick() {
-        float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, 0.0f, 500f, 0.0f);
-        float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, 0.0f, 500f, 0.0f);
+        float windDirection = this.world.getWorldType().getWindManager().getWindDirection(this.world, 0.0f, 500f, 0.0f);
+        float windIntensity = this.world.getWorldType().getWindManager().getWindIntensity(this.world, 0.0f, 500f, 0.0f);
 
         float dx = -(float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
         float dz = -(float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 6aaf4e042..96bf0b895 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -53,7 +53,7 @@ import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.weather.Weather;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
@@ -595,10 +595,10 @@ public class WorldRenderer {
             Mob activeEntity = camera.mob;
             double viewEntityX = activeEntity.xo + (activeEntity.x - activeEntity.xo) * (double) partialTicks;
             double viewEntityZ = activeEntity.zo + (activeEntity.z - activeEntity.zo) * (double) partialTicks;
-            IChunkProvider iChunkProvider = this.mc.currentWorld.getChunkProvider();
+            ChunkProvider chunkProvider = this.mc.currentWorld.getChunkProvider();
             int chunkX = MathHelper.floor_float((int) viewEntityX) >> 4;
             int chunkZ = MathHelper.floor_float((int) viewEntityZ) >> 4;
-            iChunkProvider.setCurrentChunkOver(chunkX, chunkZ);
+            chunkProvider.setCurrentChunkOver(chunkX, chunkZ);
         }
 
         this.fogManager.updateFogColor(partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 20231603c..a04cb277b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFire;
@@ -44,7 +45,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
         int y = tilePos.y();
         int z = tilePos.z();
 
-        if (this.overrideRender || worldSource.isBlockNormalCube(tilePos.down(queryPos)) || BlockLogicFire.canBurn(worldSource, tilePos.down(queryPos)) || worldSource == WorldClient.EMPTY_WORLD) {
+        if (this.overrideRender || worldSource.isBlockNormalCube(tilePos.down(queryPos)) || BlockLogicFire.canBurn(worldSource, tilePos.down(queryPos)) || worldSource == WorldEmpty.INSTANCE) {
             double d8 = (double) x + 0.5D + 0.2D;
             double d9 = ((double) x + 0.5D) - 0.2D;
             double d12 = (double) z + 0.5D + 0.2D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
index 0ec6906a1..06e2ed886 100644
--- a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -35,7 +35,7 @@ public class Colorizer {
         String path = null;
 
         // First, check for worldtype overrides
-        WorldType worldType = minecraft.currentWorld.worldType;
+        WorldType worldType = minecraft.currentWorld.getWorldType();
         if (worldType == WorldTypes.OVERWORLD_HELL) {
             path = "/assets/minecraft/textures/colormap/" + this.name + "/hell.png";
             this.texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
index 6c56a558b..2fcb86f46 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldEmpty;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.client.render.particle.ParticleFirefly;
 import org.jetbrains.annotations.NotNull;
@@ -21,7 +22,7 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
 
     public MobRendererFireflyCluster() {
         for (int i = 0; i < 20; i++) {
-            final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
+            final ParticleFirefly fx = new ParticleFirefly(WorldEmpty.INSTANCE, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
             fx.noPhysics = true;
             fx.setAge(this.rand.nextInt(20));
             this.fireflies.add(fx);
@@ -67,7 +68,7 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
         if (this.fireflies.size() < 20) {
             for (int i = this.fireflies.size(); i < 20; i++) {
                 if (this.rand.nextInt(4) == 0) continue;
-                final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
+                final ParticleFirefly fx = new ParticleFirefly(WorldEmpty.INSTANCE, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
                 fx.noPhysics = true;
                 fx.setAge(this.rand.nextInt(20));
                 this.fireflies.add(fx);
